#!/bin/sh


my_print ()
{
    echo "$@" >> /dev/console
    echo "$@"
}

channels_list_on_2_4GHz="1 2 3 4 5 6 7 8 9 10 11 12 13 14"
channels_list_on_5GHz="36 40 44 48 52 56 60 64 100 104 108 112 116 132 136 140 144 149 153 157 161 165"

is_a_valid_channel()
{
    for i in $2
    do
        if [ $i = $1 ]
        then
            echo "true"
            return
        fi
    done

    echo $false
}

if [ $# -eq 0 ]; then
    my_print "$0 : No arguments..."
    autoselect_mode=`grep wifi_autoselect_mode /data/dragon.conf | cut -d ':' -f 2 | cut -d '"' -f 2`
    band=`grep wifi_band /data/dragon.conf | awk -F ':' '{print $2+0}'`
    chan=`grep wifi_channel /data/dragon.conf | awk -F ':' '{print $2+0}'`
else
    my_print "$0 : Arguments :"
    band=$1
    my_print "$0 : band = $band"
    shift
    if [ $# -ne 0 ]; then
        chan=$1
        my_print "$0 : chan = $chan"
    else
        chan=`grep wifi_channel /data/dragon.conf | awk -F ':' '{print $2+0}'`
        my_print "$0 : (from config) chan = $chan"
    fi
    autoselect_mode="none"
    my_print "$0 : Force autoselect_mode to \"$autoselect_mode\""
fi

if [ $autoselect_mode = "2.4GHz" ]
then
    bcmwl band b
    bcmwl chanspec 6/20
    if [ $(is_a_valid_channel $chan "$channels_list_on_2_4GHz") = "true" ]
    then
        bcmwl chanspec $chan/20
    fi
elif [ $autoselect_mode = "5GHz" ]
then
    bcmwl band a
    bcmwl chanspec 40/20
    bcmwl dfs_channel_forced 40
    if [ $(is_a_valid_channel $chan "$channels_list_on_5GHz") = "true" ]
    then
        bcmwl chanspec $chan/20
        bcmwl dfs_channel_forced $chan
    fi
else
    if [ $band -eq 0 ]
    then
        bcmwl band b
        bcmwl chanspec 6/20
        if [ $(is_a_valid_channel $chan "$channels_list_on_2_4GHz") = "true" ]
        then
            bcmwl chanspec $chan/20
        fi
    elif [ $band -eq 1 ]
    then
        bcmwl band a
        bcmwl chanspec 40/20
        bcmwl dfs_channel_forced 40
        if [ $(is_a_valid_channel $chan "$channels_list_on_5GHz") = "true" ]
        then
            bcmwl chanspec $chan/20
            bcmwl dfs_channel_forced $chan
        fi
    fi
fi

SSID=`grep product_name /data/dragon.conf | cut -d ':' -f 2 | cut -d '"' -f 2`
my_print "Apply SSID : $SSID"
bcmwl ssid "$SSID"
